-- DDL
DROP TABLE IF EXISTS proposals;
DROP TABLE IF EXISTS orders;
DROP TABLE IF EXISTS incidents;
DROP TABLE IF EXISTS vendor_status ;
DROP TABLE IF EXISTS users;
DROP TABLE IF EXISTS roles ;
DROP TABLE IF EXISTS CAR_MODELS ;
DROP TABLE IF EXISTS CAR_BRANDS ;

CREATE TABLE  ROLES
(
    ID    INT PRIMARY KEY,
    ROLE_NAME  VARCHAR(10) NOT NULL
);

CREATE TABLE USERS
(
    ID       INT  AUTO_INCREMENT,
    NAME     VARCHAR(20),
    EMAIL    VARCHAR(50) NOT NULL,
    PASSWORD VARCHAR(100) NOT NULL,
    PHONE    VARCHAR(20) NOT NULL,
    ROLE_ID     INT NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (ROLE_ID) REFERENCES ROLES(ID)
);

CREATE TABLE  VENDOR_STATUS
(
    ID    INT AUTO_INCREMENT,
    VENDOR_ID  INT NOT NULL,
    STATUS VARCHAR(20) NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (VENDOR_ID) REFERENCES USERS(ID)
);

CREATE TABLE INCIDENTS
(
    ID          INT  AUTO_INCREMENT,
    USER_ID     INT NOT NULL,
    DESCRIPTION VARCHAR(200) NOT NULL,
    CAR_BRAND   VARCHAR(50),
    CAR_MODEL   VARCHAR(50),
    CAR_WEIGHT  INT,
    LOC_FROM VARCHAR(50),
    LOC_TO   VARCHAR(50),
    IN_ORDER BOOLEAN NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (USER_ID) REFERENCES USERS(ID)
);

CREATE TABLE PROPOSALS
(
    ID          INT  AUTO_INCREMENT,
    VENDOR_ID     INT NOT NULL,
    INCIDENT_ID INT NOT NULL,
    PRICE    FLOAT NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (VENDOR_ID) REFERENCES USERS(ID),
    FOREIGN KEY (INCIDENT_ID) REFERENCES INCIDENTS(ID)
);

CREATE TABLE ORDERS
(
    ID       INT  AUTO_INCREMENT,
    DATE     TIMESTAMP WITH TIME ZONE NOT NULL,
    VENDOR_ID   INT NOT NULL,
    INCIDENT_ID INT NOT NULL,
    PRICE    FLOAT NOT NULL,
    STATUS   VARCHAR(50) NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (VENDOR_ID) REFERENCES USERS (ID),
    FOREIGN KEY (INCIDENT_ID) REFERENCES INCIDENTS (ID)
);
CREATE TABLE CAR_BRANDS
(
    ID          INT  AUTO_INCREMENT,
    BRAND_NAME  VARCHAR(50) NOT NULL,
    PRIMARY KEY (ID)
);

CREATE TABLE CAR_MODELS
(
    ID           INT  AUTO_INCREMENT,
    BRAND        INT NOT NULL,
    MODEL_NAME   VARCHAR(50) NOT NULL,
    PRIMARY KEY (ID),
    FOREIGN KEY (BRAND) REFERENCES CAR_BRANDS (ID)
    );
COMMIT;